import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import java.lang.*;


public class SaveRestoreServlet extends GenericServlet implements Runnable
{
  public final static int DEFAULT_PORT=5550;
  protected int port=0;
  protected ServerSocket listen_socket;
  public static Integer p = new Integer(0);
  Thread socketThread;
  String hostName;
  int    portNumber;
  int counter=0;
    

  public void init(ServletConfig Params) throws ServletException
  {
    int port=0;
        
    //System.out.println("Module Manager accessed");
    try {
          super.init(Params);
    } catch (ServletException e)
      {  System.out.println(" Exception in init() of MM ");
         e.printStackTrace();
      }
     
    //-----
    port = DEFAULT_PORT;
    try { 
      listen_socket = new ServerSocket(port);
    } catch (IOException e) {fail(e,"Exception creating server socket");}
   
    //System.out.println("Server: listening on port " + port);
    // finally, branch new thread, set it up as a deamon (to terminate
    // upon completion of master program), and start it up

    socketThread = new Thread(this);
    socketThread.setDaemon(true);
    socketThread.start();
  
    portNumber = port;
    try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
    }catch(UnknownHostException e)
    {  hostName = "0";
       //System.out.println(" UnknownHostException in init() of MM ");
       e.printStackTrace();
    }
  

}
  
  public static void fail(Exception e, String msg) {
    System.err.println(msg+":"+e);
    System.exit(1);
  }

  public void run() {
    try {
      while(true) {
         Socket client_socket = listen_socket.accept();
         Connection c = new Connection(client_socket);
      } 
    }
    catch (IOException e) 
                    {fail(e, "Exception while listening for connections");}
  }

  public void service(ServletRequest req, ServletResponse res)
       throws ServletException, IOException
  {
        counter++;
    
        res.setContentType("text/plain");
        OutputStream os = res.getOutputStream();
        PrintStream out = new PrintStream( os );
        out.println(hostName);
        out.println(portNumber);
        out.println("EROL:counter:"+counter);
        out.flush();

    
  }
  
}

class Connection extends Thread {
    protected Socket client;
    protected DataInputStream dis;
    protected DataOutputStream dos;
    ObjectInputStream socket_oIS;
    ObjectOutputStream socket_oOS ;
    File file ;
  
  String m1;
  int aport;
  Integer p;

  public Connection(Socket client_socket) {
  client = client_socket;
  try {
        dis = new DataInputStream(client.getInputStream());
        dos = new DataOutputStream(client.getOutputStream());
	socket_oIS=new ObjectInputStream(client.getInputStream());
	socket_oOS=new ObjectOutputStream(client.getOutputStream());
	file = new File("/tmp","Networks3");
  }
  catch (IOException e) {
         try {client.close();}
         catch (IOException e2) {;}
         System.err.println("Exception while getting socket streams: " + e);
         return;
  }
  this.start();
  }
  
  public void run() {
         String line;
         StringBuffer revline;
         int len;

	 try{
	   
	   String message = receive();
           if(message.startsWith("SAVE")) {
              m1 = message.substring("SAVE".length());
              System.out.println("register port "+m1);
	      FileOutputStream  fileOS = new FileOutputStream(file); 
	      ObjectOutputStream oOS = new ObjectOutputStream(fileOS);
	      Object target = socket_oIS.readObject();
	      oOS.writeObject(target);
	      oOS.flush();
	      oOS.close();
	      fileOS.close();
	   }
	   else if (message.startsWith("RESTORE")){
	     FileInputStream  fileIS = new FileInputStream(file); 
	     ObjectInputStream oIS = new ObjectInputStream(fileIS);
	     Object target = oIS.readObject();
	     socket_oOS.writeObject(target);
	     socket_oOS.flush();
	     fileIS.close();
	     oIS.close();
	   }

        }catch(ClassNotFoundException cNFE) { 
	  System.out.println(cNFE); 
	}
	catch(IOException e){
	  System.out.println("IOException during file :"+e);
	}
	
  }
  
	   	   
	   
public void send(String message)
  {

    int sl = message.length();
    byte[] buf =new byte[sl];
    message.getBytes(0,sl,buf,0); 
    System.out.println("Trying to send... "+message);
    
    try{
      dos.writeInt(sl);
      dos.write(buf,0,sl);
      dos.flush();
    } catch(IOException e) {System.out.println(e);}
  }

public String receive()
  {
    String message = "";
    try{
      int ls=dis.readInt();
      System.out.println("strlen "+ls);
      byte buf[] = new byte[ls];
      dis.read(buf,0,ls);
      message = new String(buf,0,ls);
      System.out.println("I have received from Applet: "+message);
    } catch(IOException e){
      System.out.println(e);
      stop();
    }
    return(message);
  }

}  

 
